
local bar; -- Createt Actionbar Object

function CPala:InitActionBar()
	local db = self.db.char; -- our database

	--Bar Bound to Box Always Visible
	local box = CPala.Class.Box:new("CTestBox1", "Drag Me", 60, 20, self.db.char.actionBox.x, self.db.char.actionBox.y);
	box.box:SetFrameStrata("HIGH");
	if db.boxLock then
		box:Hide();
	else
		box:Show();
	end;
	box:Unlock();
	box.DragEnd = function (x, y)
		db.actionBox.x = x;
		db.actionBox.y = y;
	end;
	CPala.actionBox = box;

	-- Create Bar
	bar = CPala.Class.BaseBar:new("CPalaMainActionBar")
	bar.frame:ClearAllPoints();
	bar.frame:SetPoint("TOPLEFT", "CTestBox1", "TOPLEFT", 20, -40);
	bar:VisibleOnlyForUnit("target", true);

	local button, key;
	for i = 1, 12 do
		button = bar:AddButton(CPala.Class.ActionButton);
	--[[	if i < 10 then
			key = tostring(i)
		elseif i == 10 then
			key = "0";
		elseif i == 11 then
			key = "\195\159";
		elseif i == 12 then
			key = "\194\180";			
		end; ]]
		key = GetBindingKey("ACTIONBUTTON" .. i);
		button:Setup("B"..i, key, true, bar.frame);
		button:SetButtonActionMulti(tostring(i), tostring(i+12), "target")		
		button.frame:SetFrameStrata("HIGH");
	end;
	
	--Set Button Scale & Spacing
	self:SetButtonScale(db.actionBox.scale, true);
	self:SetButtonPositionType(db.actionBox.type, true);
	
	for i = 1, 12 do
		button = getglobal("ActionButton" .. i );
		button:UnregisterAllEvents();
		button:Hide();
	end;	
end;

--value = the value to set, force = force the resizing (even if value is the same)
function CPala:SetButtonScale(value, force)	
	local db = self.db.char.actionBox;
	if (db.scale ~= value) or force then
		bar:SetButtonScale(value);
		db.scale = value;		
		if (not force) then -- reset spacing if changing scale
			self:SetButtonSpaceingH(db.spaceingH, true);
			self:SetButtonSpaceingV(db.spaceingV, true);
		end;
	end;
end

function CPala:SetButtonSpaceingH(value, force)
	-- Base Size is 42 x 42 set scale based on this
	local db = self.db.char.actionBox;
	if (db.spaceingH ~= value) or force then		
		bar:UpdateButtonPosition(db.type, value, db.spaceingV);
		db.spaceingH = value;
		bar.frame:SetAttribute("state", "0");  --Make Changes Visible
		bar.frame:SetAttribute("state", "1");
	end;
end;

function CPala:SetButtonSpaceingV(value, force)
	local db = self.db.char.actionBox;
	if (db.spaceingV ~= value) or force then		
		bar:UpdateButtonPosition(db.type, db.spaceingH, value);
		db.spaceingV = value;
		bar.frame:SetAttribute("state", "0"); --Make Changes Visible
		bar.frame:SetAttribute("state", "1");
	end;
end;


function CPala:SetButtonPositionType(value, force)
	--Make Changes Visible
	if (self.db.char.actionBox.type ~= value) or force then			
		self.db.char.actionBox.type = value;
		bar:UpdateButtonPosition(self.db.char.actionBox.type, self.db.char.actionBox.spaceingH, self.db.char.actionBox.spaceingV);		
		bar.frame:SetAttribute("state", "0");
		bar.frame:SetAttribute("state", "1");		
	end;
end;

function CPala:SetActionBarKeys()
	local button, key, key2;
	local array = bar.buttons;
	for i = 1, 12 do
		button = array[i].obj;
		key, key2 = GetBindingKey("ACTIONBUTTON" .. i);
		if (key) then
			button:SetKey(key, key2);
		end;
	end		
end;
