
local AceOO = AceLibrary("AceOO-2.0");

CPala.Class.ActionButton = AceOO.Class(CPala.Class.BaseButton);

function CPala.Class.ActionButton.prototype:init(name, parent)
	CPala.Class.ActionButton.super.prototype.init(self, name, "SecureActionButtonTemplate, ActionButtonTemplate", "CheckButton", parent);

	local b = self.frame;

	b.showgrid = 0;
	b.flashing = 0;
	b.flashtime = 0;
	b.hotkey = getglobal(b:GetName().."HotKey");
	b.icon = getglobal(b:GetName().."Icon");
	b.normal = getglobal(b:GetName().."NormalTexture");
	local buttonCooldown = getglobal(b:GetName().."Cooldown");   
	b.cooldown = buttonCooldown;
		
	self:Update();
	b:RegisterForDrag("LeftButton", "RightButton");
	b:RegisterForClicks("AnyUp");

	b:SetScript("OnUpdate", function(teer, elapsed) self.OnUpdate(self, elapsed) end);

	b:SetScript("OnEvent", function(teer, event, arg1, arg2, arg3, arg4) self.OnEvent(self, event, arg1, arg2, arg3, arg4) end);

	b:SetScript("PostClick", function(teer, button)
         			--[[if ( self.ShouldPickupAction(self, button) ) then
					PickupAction(self.GetPagedID(self));
				end]]
                                 self.UpdateState(self) end);

         b:SetScript("OnDragStart",  function()
         			if ( LOCK_ACTIONBAR ~= "1" ) then
					PickupAction(self.GetPagedID(self));
					--self.UpdateHotkeys(self, this.buttonType);
					self.UpdateState(self);
					self.UpdateFlash(self);
                                         --self.Update(self);
				end end);

         b:SetScript("OnReceiveDrag", function() if ( LOCK_ACTIONBAR ~= "1" ) then
					PlaceAction(self.GetPagedID(self));
					--self.UpdateHotkeys(self, this.buttonType);
					self.UpdateState(self);
					self.UpdateFlash(self);
                    --self.Update(self);
				end end);
				
	b:SetScript("OnEnter", function() 
		self.SetTooltip(self); 
	end);

	b:SetScript("OnLeave", function() this.updateTooltip = nil;
		GameTooltip:Hide();
	end);

	-- fix some things with visibility of frames ...   
	buttonCooldown:SetFrameStrata("HIGH");
	buttonCooldown:SetFrameLevel(3);

	b:RegisterEvent("PLAYER_ENTERING_WORLD");
	--b:RegisterEvent("UPDATE_BONUS_ACTIONBAR");
	--b:RegisterEvent("ACTIONBAR_SHOWGRID");
	--b:RegisterEvent("ACTIONBAR_HIDEGRID");
	b:RegisterEvent("ACTIONBAR_PAGE_CHANGED");
	b:RegisterEvent("ACTIONBAR_SLOT_CHANGED");
	--b:RegisterEvent("UPDATE_BINDINGS");
    
	b:RegisterEvent("PLAYER_TARGET_CHANGED");
end


function CPala.Class.ActionButton.prototype:Setup(name, key, static, parent)
    local b = self.frame;
    b.key = key;
    b:SetAttribute("showstates", "1,2");

	if (static) then
    	b:SetAttribute("newstate", "1:1;2:2");
	else
		b:SetAttribute("newstate", 0);
	end;
	
	
	local hotkey = b.hotkey;
	hotkey:SetText(key);	
	b:SetAttribute("bindings-top", key);
	b:SetAttribute("bindings-nounit", key);
	b:SetAttribute("anchorchild", parent);
	parent:SetAttribute("AddChild", b);
	b:SetAttribute("statebutton", "1:decide;2:default");
    
end;

function CPala.Class.ActionButton.prototype:SetKey(key)
	CPala.Class.ActionButton.super.prototype.SetKey(self, key);	
	local hotkey = self.frame.hotkey;
	hotkey:SetText(key);	
end;

function CPala.Class.ActionButton.prototype:SetButtonActionSingle(id, unit)
    local b = self.frame;

	b:SetAttribute("type", "action");
	b:SetAttribute("action" , id);
	b:SetAttribute("unit", unit);

         self.unit = unit;
         self.id = id;

         self:Update();
end;

function CPala.Class.ActionButton.prototype:SetButtonActionMulti(id, id2, unit)

	local b = self.frame;

         b:SetAttribute("*unit-decide", unit);

         b:SetAttribute("*harmbutton-decide", "harm1");
    	b:SetAttribute("*type-harm1", "action");
   	b:SetAttribute("*action-harm1", id);

   	b:SetAttribute("*helpbutton-decide", "help1");
    	b:SetAttribute("*type-help1", "action");
    	b:SetAttribute("*action-help1", id2);

         b:SetAttribute("*unit-default", "player");
        	b:SetAttribute("*type-default", "action");
        	b:SetAttribute("*action-default", id);

         self.unit = unit;
         self.harm = tonumber(id);
         self.help = tonumber(id2);

         self:Update();
end;

function CPala.Class.ActionButton.prototype:Update()

	local b = self.frame;
	local icon = b.icon;
	local buttonCooldown = b.cooldown;
	local button = self:GetPagedID();
	local texture = GetActionTexture(button);
	
	if ( texture ) then
		icon:SetTexture(texture);
		icon:Show();
		b.rangeTimer = -1;
		b:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
         	-- Save texture if the button is a bonus button, will be needed later
	  --[[	if ( b.isBonus ) then
			b.texture = texture;
		end ]]
	else
		icon:Hide();
		buttonCooldown:Hide();
		b.rangeTimer = nil;
		b:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");
		b.hotkey:SetVertexColor(0.6, 0.6, 0.6);
	end
	self:UpdateCount();
	if ( HasAction(button) ) then
		b:RegisterEvent("ACTIONBAR_UPDATE_STATE");
		b:RegisterEvent("ACTIONBAR_UPDATE_USABLE");
		b:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
		b:RegisterEvent("UPDATE_INVENTORY_ALERTS");
		b:RegisterEvent("PLAYER_AURAS_CHANGED");
		--b:RegisterEvent("PLAYER_TARGET_CHANGED");
		b:RegisterEvent("UNIT_INVENTORY_CHANGED");
		b:RegisterEvent("CRAFT_SHOW");
		b:RegisterEvent("CRAFT_CLOSE");
		b:RegisterEvent("TRADE_SKILL_SHOW");
		b:RegisterEvent("TRADE_SKILL_CLOSE");
		b:RegisterEvent("PLAYER_ENTER_COMBAT");
		b:RegisterEvent("PLAYER_LEAVE_COMBAT");
		b:RegisterEvent("START_AUTOREPEAT_SPELL");
		b:RegisterEvent("STOP_AUTOREPEAT_SPELL");

		--[[if ( not b:GetAttribute("statehidden") ) then
			b:Show();
		end]]
		self:UpdateState();
		self:UpdateUsable();
		self:UpdateCooldown();
		self:UpdateFlash();
	else
		b:UnregisterEvent("ACTIONBAR_UPDATE_STATE");
		b:UnregisterEvent("ACTIONBAR_UPDATE_USABLE");
		b:UnregisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
		b:UnregisterEvent("UPDATE_INVENTORY_ALERTS");
		b:UnregisterEvent("PLAYER_AURAS_CHANGED");
		--b:UnregisterEvent("PLAYER_TARGET_CHANGED");
		b:UnregisterEvent("UNIT_INVENTORY_CHANGED");
		b:UnregisterEvent("CRAFT_SHOW");
		b:UnregisterEvent("CRAFT_CLOSE");
		b:UnregisterEvent("TRADE_SKILL_SHOW");
		b:UnregisterEvent("TRADE_SKILL_CLOSE");
		b:UnregisterEvent("PLAYER_ENTER_COMBAT");
		b:UnregisterEvent("PLAYER_LEAVE_COMBAT");
		b:UnregisterEvent("START_AUTOREPEAT_SPELL");
		b:UnregisterEvent("STOP_AUTOREPEAT_SPELL");

	--[[	if ( b.showgrid == 0 ) then
			if (not InCombatLockdown()) then
				b:Hide();
			else
				buttonCooldown:Hide();
			end;
		else ]]
		buttonCooldown:Hide();
	--	end
	end

	-- Add a green border if button is an equipped item
	local border = getglobal(b:GetName().."Border");
	if ( IsEquippedAction(button) ) then
		border:SetVertexColor(0, 1.0, 0, 0.35);
		border:Show();
	else
		border:Hide();
	end

	if ( GameTooltip:IsOwned(this) ) then
		self:SetTooltip();
	else
		b.updateTooltip = nil;
	end

	-- Update Macro Text
	local macroName = getglobal(b:GetName().."Name");
	macroName:SetText(GetActionText(button));
end


function CPala.Class.ActionButton.prototype:ShowGrid(button)
	if (not InCombatLockdown()) then
		if ( not button ) then
			button = self.frame;
		end
		button.showgrid = button.showgrid+1;
		b.normal:SetVertexColor(1.0, 1.0, 1.0, 0.5);
       
		--if ( not button:GetAttribute("statehidden") ) then
			button:Show();
		--end
	end;
end

function CPala.Class.ActionButton.prototype:HideGrid(button)
	if (not InCombatLockdown()) then
		if ( not button ) then
			button = self.frame;
		end
		button.showgrid = button.showgrid-1;
		if ( button.showgrid == 0 and not HasAction(self:GetPagedID()) ) then
			button:Hide();
		end
	end;
end

function CPala.Class.ActionButton.prototype:UpdateState(button)
	if ( not button ) then
		button = self.frame;
	end
	local actionID = self:GetPagedID();
	if ( IsCurrentAction(actionID) or IsAutoRepeatAction(actionID) ) then
		button:SetChecked(1);
	else
		button:SetChecked(0);
	end
end

function CPala.Class.ActionButton.prototype:UpdateUsable()
	local b = self.frame;
	local icon = b.icon;
	local normalTexture = b.normal;
	local isUsable, notEnoughMana = IsUsableAction(self:GetPagedID());
	if ( isUsable ) then
		icon:SetVertexColor(1.0, 1.0, 1.0);
		normalTexture:SetVertexColor(1.0, 1.0, 1.0);
	elseif ( notEnoughMana ) then
		icon:SetVertexColor(0.1, 0.1, 1.0);
		normalTexture:SetVertexColor(0.1, 0.1, 1.0);
	else
		icon:SetVertexColor(0.4, 0.4, 0.4);
		normalTexture:SetVertexColor(1.0, 1.0, 1.0);
	end
end

function CPala.Class.ActionButton.prototype:UpdateCount()
	local b = self.frame;
	local text = getglobal(b:GetName().."Count");
	local action = self:GetPagedID();
	if ( IsConsumableAction(action) or IsStackableAction(action) ) then
		text:SetText(GetActionCount(action));
	else
		text:SetText("");
	end
end

function CPala.Class.ActionButton.prototype:UpdateCooldown()
	local b = self.frame;
	local cooldown = b.cooldown;
	local start, duration, enable = GetActionCooldown(self:GetPagedID());
     	CooldownFrame_SetTimer(cooldown, start, duration, enable);
end

function CPala.Class.ActionButton.prototype:OnEvent(event, arg1, arg2, arg3)
	local b = self.frame;

    if ( event == "ACTIONBAR_SLOT_CHANGED" ) then
		if ( arg1 == 0 or arg1 == self:GetPagedID() ) then
        	self:Update();
		end
		return;
	end
	if ( event == "PLAYER_ENTERING_WORLD" or event == "ACTIONBAR_PAGE_CHANGED" or event == "PLAYER_TARGET_CHANGED" ) then
		self:Update();		
		return;
	end
      --[[	if ( event == "UPDATE_BONUS_ACTIONBAR" ) then
		if ( b.isBonus ) then
			self:Update();
		end
		return;
	end ]]
	--[[if ( event == "ACTIONBAR_SHOWGRID" ) then
      		self:ShowGrid();
		return;
	end
	if ( event == "ACTIONBAR_HIDEGRID" ) then
		self:HideGrid();
		return;
	end]]
	--[[if ( event == "UPDATE_BINDINGS" ) then
		self:UpdateHotkeys(b.buttonType);
		return;
	end]]

	-- All event handlers below this line are only set when the button has an action
	--[[if ( event == "PLAYER_TARGET_CHANGED") then
		self:Update();  
	else ]] 
	if ( --[[event == "PLAYER_TARGET_CHANGED" or ]]event == "PLAYER_AURAS_CHANGED" ) then
		self:UpdateUsable();
		--self:UpdateHotkeys(b.buttonType);
	elseif ( event == "UNIT_INVENTORY_CHANGED" ) then
		if ( arg1 == "player" ) then
			self:Update();
		end
	elseif ( event == "ACTIONBAR_UPDATE_STATE" ) then
		self:UpdateState();
	elseif ( event == "ACTIONBAR_UPDATE_USABLE" or event == "UPDATE_INVENTORY_ALERTS" or event == "ACTIONBAR_UPDATE_COOLDOWN" ) then
		self:UpdateUsable();
		self:UpdateCooldown();
	elseif ( event == "CRAFT_SHOW" or event == "CRAFT_CLOSE" or event == "TRADE_SKILL_SHOW" or event == "TRADE_SKILL_CLOSE" ) then
		self:UpdateState();
	elseif ( event == "PLAYER_ENTER_COMBAT" ) then
		if ( IsAttackAction(self:GetPagedID()) ) then
			self:StartFlash();
		end
	elseif ( event == "PLAYER_LEAVE_COMBAT" ) then
		if ( IsAttackAction(self:GetPagedID()) ) then
			self:StopFlash();
		end
	elseif ( event == "START_AUTOREPEAT_SPELL" ) then
		if ( IsAutoRepeatAction(self:GetPagedID()) ) then
			self:StartFlash();
		end
	elseif ( event == "STOP_AUTOREPEAT_SPELL" ) then
		if ( self:IsFlashing() and not IsAttackAction(self:GetPagedID()) ) then
			self:StopFlash();
		end
	end
end

function CPala.Class.ActionButton.prototype:ShouldPickupAction(button)
	return (IsShiftKeyDown()); -- and not SecureButton_GetModifiedAttribute(self, "type", button));
end

function CPala.Class.ActionButton.prototype:SetTooltip()
	local b = self.frame;
	if ( GetCVar("UberTooltips") == "1" ) then
		GameTooltip_SetDefaultAnchor(GameTooltip, b);
	else
		if ( b:GetParent() == MultiBarBottomRight or b:GetParent() == MultiBarRight or b:GetParent() == MultiBarLeft ) then
			GameTooltip:SetOwner(b, "ANCHOR_LEFT");
		else
			GameTooltip:SetOwner(b, "ANCHOR_RIGHT");
		end

	end

	if ( GameTooltip:SetAction(self:GetPagedID()) ) then
		b.updateTooltip = TOOLTIP_UPDATE_TIME;
	else
		b.updateTooltip = nil;
	end
end

function CPala.Class.ActionButton.prototype:OnUpdate(elapsed)

	local b = self.frame;
	local hotkey = b.hotkey;
	local button = self:GetPagedID();
	local icon = b.icon;

--[[	if ( hotkey:GetText() == RANGE_INDICATOR ) then
		if ( IsActionInRange(button) == 1 ) then
			hotkey:Hide();
		else
			hotkey:Show();
		end
	end
]]
	if ( self:IsFlashing() ) then
		b.flashtime = b.flashtime - elapsed;
		if ( b.flashtime <= 0 ) then
			local overtime = -b.flashtime;
			if ( overtime >= ATTACK_BUTTON_FLASH_TIME ) then
				overtime = 0;
			end
			b.flashtime = ATTACK_BUTTON_FLASH_TIME - overtime;

			local flashTexture = getglobal(b:GetName().."Flash");
			if ( flashTexture:IsVisible() ) then
				flashTexture:Hide();
			else
				flashTexture:Show();
			end
		end
	end

	-- Handle range indicator
	if ( b.rangeTimer ) then
		local normalTexture = b.normal;
		b.rangeTimer = b.rangeTimer - elapsed;

		if (b.rangeTimer <= 0 ) then
			if ( IsActionInRange(button, self.unit) == 0 ) then
				icon:SetVertexColor(1.0, 0.1, 0.1);
				hotkey:SetVertexColor(1.0, 0.1, 0.1);
				normalTexture:SetVertexColor(1.0, 1.0, 1.0);
			else
				local isUsable, notEnoughMana = IsUsableAction(button);
				if ( isUsable ) then
					icon:SetVertexColor(1.0, 1.0, 1.0);
					normalTexture:SetVertexColor(1.0, 1.0, 1.0);
				elseif ( notEnoughMana ) then
					icon:SetVertexColor(0.1, 0.1, 1.0);
					normalTexture:SetVertexColor(0.1, 0.1, 1.0);
				else
					icon:SetVertexColor(0.4, 0.4, 0.4);
					normalTexture:SetVertexColor(1.0, 1.0, 1.0);
				end
				--icon:SetVertexColor(1.0, 1.0, 1.0);
				hotkey:SetVertexColor(0.6, 0.6, 0.6);
			end
			b.rangeTimer = TOOLTIP_UPDATE_TIME;
		end
	end

	if ( not b.updateTooltip ) then
		return;
	end

	b.updateTooltip = b.updateTooltip - elapsed;
	if ( b.updateTooltip > 0 ) then
		return;
	end

	if ( GameTooltip:IsOwned(b) ) then
		self:SetTooltip();
	else
		b.updateTooltip = nil;
	end
end


function CPala.Class.ActionButton.prototype:GetPagedID()
	if (self.id ~= nil) then
        return self.id  --single action
    elseif (not UnitExists(self.unit)) or (UnitCanAttack("player", self.unit)) then
        return self.harm or 1;
	elseif (UnitCanAssist("player", self.unit)) then
       	return self.help or 1;
    end
        return self.harm or 1;
end

function CPala.Class.ActionButton.prototype:UpdateFlash()
	local pagedID = self:GetPagedID();
	if ( (IsAttackAction(pagedID) and IsCurrentAction(pagedID)) or IsAutoRepeatAction(pagedID) ) then
		self:StartFlash();
	else
		self:StopFlash();
	end
end

function CPala.Class.ActionButton.prototype:StartFlash()
	local b = self.frame;
	b.flashing = 1;
	b.flashtime = 0;
	self:UpdateState();
end

function CPala.Class.ActionButton.prototype:StopFlash()
	self.frame.flashing = 0;
	getglobal(self.frame:GetName().."Flash"):Hide();
	self:UpdateState();
end

function CPala.Class.ActionButton.prototype:IsFlashing()
	if ( self.frame.flashing == 1 ) then
		return 1;
	else
		return nil;
	end
end

function CPala.Class.ActionButton.prototype:UpdateHotkeys(actionButtonType)
   local b = self.frame;
 --   if ( not actionButtonType ) then
   --     actionButtonType = "ACTIONBUTTON";
    --end
    local hotkey = b.hotkey;
    local button = self:GetPagedID();
    --local key = GetBindingKey(actionButtonType..b:GetID()) or
    --            GetBindingKey("CLICK "..this:GetName()..":LeftButton");
    --TODO	
    key = b.key or "1";
	
	hotkey:SetText(key);

    --if ( GetBindingText(key, "KEY_", 1) == "" ) then
--[[        if ( not HasAction(button) ) then
            hotkey:SetText("");
        elseif ( ActionHasRange(button) ) then
            if ( IsActionInRange(button) ) then
                hotkey:SetText(RANGE_INDICATOR);
                hotkey:SetTextHeight(10);
                hotkey:SetPoint("TOPRIGHT", b:GetName(), "TOPRIGHT", -3, 5);
            else
                hotkey:SetText("");
            end
        end
    --else
        hotkey:SetText(key);
    --end ]]
end
