--[[ Ace OO Klasse fr ein einfaches Button mit einer statischen Textur und der Keybinding anzeige ]]

-- (Das solls zumindest mal werden)

local AceOO = AceLibrary("AceOO-2.0");
local REFRESH_TIME = 0.25;

CPala.Class.BaseButton = AceOO.Class();

function CPala.Class.BaseButton.prototype:init(name, template, frame, parent)
	CPala.Class.BaseButton.super.prototype.init(self);

	if (not template) then
		template = "CMenuButtonTemplate";
	end;

	if (not frame) then
		frame = "Button";
	end;

	local b = CreateFrame(frame, name, parent, template);
	self.frame = b;
end

function CPala.Class.BaseButton.prototype:Setup(name, key, static, parent)
	local b = self.frame;
	b.title:SetText(name);
	b:SetWidth(32);
	b:SetHeight(32);
	b.number:SetText(key);

	b:SetAttribute("showstates", "1,2");
    if (static) then
    	b:SetAttribute("newstate", "1:1;2:2");
	else
		b:SetAttribute("newstate", 0);
	end;

	b:RegisterForClicks("AnyUp");
    b:SetAttribute("bindings-top", key);
	b:SetAttribute("bindings-nounit", key);
	b:SetAttribute("anchorchild", parent);
	
	parent:SetAttribute("AddChild", b);
	b:SetAttribute("statebutton", "1:decide;2:default")
end;


function CPala.Class.BaseButton.prototype:SetKey(key, key2)
	local b = self.frame;	
	b:SetAttribute("bindings-top", "");
	b:SetAttribute("bindings-nounit", "");
	if (key2) then
		b:SetAttribute("bindings-top", key .. ";" .. key2);
		b:SetAttribute("bindings-nounit", key .. ";" .. key2);
	else
		b:SetAttribute("bindings-top", key);
		b:SetAttribute("bindings-nounit", key);
	end;
end;



-- Update Textures For Buttons
local function childOnShow(self)
    self.refreshtime = 0;
end

local function childOnUpdate(self, elapsed)
    local remaining = (self.refreshtime or 0) - elapsed;
    if (remaining > 0) then
		self.refreshtime = remaining;
	return;
    end
    local ext = "";
    local button = "decide";
  --[[  if (self.unit) then
    	button = SecureStateChild_GetEffectiveButton(self);
    	if UnitCanAttack("player", self.unit) then
       		ext = "-harm"
    	else
    		ext = "-help"
    	end
    end;
    ]]

    -- Lookup the unit, based on the modifiers and button


	if (self.special) then
		button = "decide";
              	if (not UnitExists("target")) then
              		button = "default"
              	elseif UnitCanAttack("player", "target") then
                 	button = "decide"
                 elseif UnitCanAssist("player", "target") then
                 	button = "decide"
                 else
                 	button = "default"
                 end
	    	--ChatFrame1:AddMessage("Button State : "..  (self:GetAttribute("state") or "none") .. " unit " .. unit or "none");
	end;

         local unit = SecureButton_GetModifiedUnit(self, button);

	-- Remap button suffixes based on the disposition of the unit (contributed by Iriel and Cladhaire)
	if ( unit ) then
		local origButton = button;
		if ( UnitCanAttack("player", unit) )then
			button = SecureButton_GetModifiedAttribute(self, "harmbutton", button) or button;
		elseif ( UnitCanAssist("player", unit) )then
			button = SecureButton_GetModifiedAttribute(self, "helpbutton", button) or button;
		end

		-- The unit may have changed based on button remapping
		if ( button ~= origButton ) then
			unit = SecureButton_GetModifiedUnit(self, button);

			-- Don't do anything if our unit doesn't exist
			if ( unit and unit ~= "none" and not UnitExists(unit) ) then
				return;
			end
		end
	end

    self.refreshtime = REFRESH_TIME;
    --local type = SecureButton_GetModifiedAttribute(self, "type" .. ext , button, "");
    local type = SecureButton_GetModifiedAttribute(self, "type", button);

    if (type == "action") then
	local action = SecureButton_GetModifiedAttribute(self, "action" .. ext, button, nil);
	action = tonumber(action);
	if (action) then

             if IsUsableAction(action) then
                	self.error:Hide();
             else
             	self.error:Show();
             end;

             if IsActionInRange(action, unit) == 0 then
             	self.number:SetTextColor(1, 0, 0);
             else
             	self.number:SetTextColor(1, 1, 1);
             end;

	    local texture = GetActionTexture(action);
	    if (texture) then
		self.texture:SetTexture(texture);
		self.texture:Show();
		return;
             else
             	self.texture:Hide();
	    end
	end
    elseif (type == "spell") then
    	local spell = SecureButton_GetModifiedAttribute(self, "spell" .. ext, button, nil);
         if (spell) then

                 if IsUsableSpell(spell) then
                 	self.error:Hide();
                 else
                         self.error:Show();
                 end;

                 if IsSpellInRange(spell, unit) == 0 then
                 	self.number:SetTextColor(1, 0, 0);
                 else
                 	self.number:SetTextColor(1, 1, 1);
                 end;

                 local texture = GetSpellTexture(spell)
                 if (texture) then
                 	self.texture:SetTexture(texture);
                         self.texture:Show();
                         return;
                 else
                 	self.texture:Hide();
                 end;
         end;
    elseif (type == "pet") then
         local pet = SecureButton_GetModifiedAttribute(self, "pet" .. ext, button, nil);
         if (pet) then

                 if GetPetActionsUsable(pet) then
                 	self.error:Hide();
                 else
                         self.error:Show();
                 end;

                 local _, _, texture = GetPetActionInfo(index);
                 if (texture) then
                 	self.texture:SetTexture(texture);
                         self.texture:Show();
                         return;
                 else
                 	self.texture:Hide();
                 end;
         end;
    elseif (type == "item") then
         local item = SecureButton_GetModifiedAttribute(self, "item" .. ext, button, nil);
         if (item) then

                 if IsUsableItem(item) then
                 	self.error:Hide();
                 else
                         self.error:Show();
                 end;

                 if IsItemInRange(spell, unit) == 0 then
                 	self.number:SetTextColor(1, 0, 0);
                 else
                 	self.number:SetTextColor(1, 1, 1);
                 end;

                 local _, _, texture = GetPetActionInfo(index);
                 if (texture) then
                 	self.texture:SetTexture(texture);
                         self.texture:Show();
                         return;
                 else
                 	self.texture:Hide();
                 end;
         end;
    end;

    self.texture:Hide();
end

function CPala.Class.BaseButton.prototype:SetButtonActionSingle(type, id, texture, unit)

	local b = self.frame;

         --Set New Options
         b:SetAttribute("type", type);
    	b:SetAttribute(type , id);
	b:SetAttribute("unit", unit);


         if (texture) then
                 b.texture:SetTexture(texture);
		b.texture:Show();
         else
         	if (type == "macro") then
                         local _, texture = GetMacroInfo(id)
                         if (texture) then
                 		b.texture:SetTexture(texture);
                         	b.texture:Show();
                 	else
                 		b.texture:Hide();
                 	end;
                 else
         		b:SetScript("OnShow", childOnShow);
                 	b:SetScript("OnUpdate", childOnUpdate);
                 end;
         end;

end;

function CPala.Class.BaseButton.prototype:SetButtonActionMulti(type, id, type2, id2, texture, unit, type3, id3, unit3)

         local b = self.frame;

         b.unit = unit;
         b.special = true;

         b:SetAttribute("*unit-decide", unit);

         b:SetAttribute("*harmbutton-decide", "harm1");
    	b:SetAttribute("*type-harm1", type);
   	b:SetAttribute("*"..type .. "-harm1", id);

   	b:SetAttribute("*helpbutton-decide", "help1");
    	b:SetAttribute("*type-help1", type2);
    	b:SetAttribute("*"..type2 .. "-help1", id2);

         b:SetAttribute("*unit-default", unit3);
        	b:SetAttribute("*type-default", type3);
        	b:SetAttribute("*"..type3 .. "-default", id3);

         self.harm = tonumber(id);
         self.help = tonumber(id2);
         self.other = tonumber(id3);



      --[[	if (texture) then
        		b.texture:SetTexture(texture);
		b.texture:Show();
         else
		if (type == "macro") then
                		local index = GetMacroIndexByName(id);
			local _, texture = GetMacroInfo(index)
                 	if (texture) then
              			self.texture:SetTexture(texture);
				self.texture:Show();
              		else
              			self.texture:Hide();
               		end;
            else
		b:SetScript("OnShow", childOnShow);
               	b:SetScript("OnUpdate", childOnUpdate);
            end;
         end;  ]]
end;
