--[[ 
Class Box
Creates small little boxe for text display and draging around

Simply use new(name, text, width, height,  x, y , type, temp) with
name = Name of the Frame
text = initilay test to display
width, height = size of the frame (default 20 x 20)
x,y = absoulte position on screen (anker am Mittelpunkt)
type = type of frame to create (default frame)
temp = template for the button (default yellow box, other template should match the created sub elements)

box acesibile itself via obj.box

Other Functions
SetSize(width, height)
SetPos(x,y)
SetText(text)
Show()
Hide()
SetBorderVisible(true/false)

Lock()
Unlock()
- Enables/Disalbes Draging of Button
wenn die methode DragEnd gesetzt wird dann wird sie nach abschlieen eines Schiebe Vorgangs mit den Absoluten X, Y werten aufgerufen

]]
local AceOO = AceLibrary("AceOO-2.0");

CPala.Class.Box = AceOO.Class();

--Creates The Basic Parts
--name = The Name of the New Bar (used for frame names)
function CPala.Class.Box.prototype:init(name, text, width, height, x, y, type, temp )
	CPala.Class.Box.super.prototype.init(self)

	if not type then
		type = "Frame"
	end;
	if not temp then
		temp = "CPala_Box_Template"
	end;

	local f = CreateFrame(type, name, UIParent, temp);
	self.textFrame = getglobal(name.."_Text");
	if (f) then
		f.object = self;
		self.box = f;
		self:SetText(text);
		self:SetPos(x, y);
		self:SetSize(width, height);
		return true;
	else
		return false; -- box net erstellt!
	end;
end

function CPala.Class.Box.prototype:SetText(text)	
	self.textFrame:SetText(text);
end

function CPala.Class.Box.prototype:GetText()	
	return self.textFrame:GetText();
end

function CPala.Class.Box.prototype:Show()
	self.box:Show();
end;

function CPala.Class.Box.prototype:Hide()
	self.box:Hide();
end;

function CPala.Class.Box.prototype:Unlock()
	self.unlocked = true;
end;

function CPala.Class.Box.prototype:Lock()
	self.unlocked = nil;
end;

function CPala.Class.Box.prototype:SetPos(x, y)	
	if (x) and (y) then
		self.box:ClearAllPoints();
		self.box:SetPoint("TOPLEFT", nil, "TOPLEFT", x, y)
	end;
end;


function CPala.Class.Box.prototype:SetSize(width, height)
	local border;
	local name = self.box:GetName();
	local f = self.box;
	if (width) then
		f:SetWidth(width);
		border = getglobal(name.."_1");
		border:SetWidth(width);
		border = getglobal(name.."_2");
		border:SetWidth(width);
	end;
	if (height) then
		f:SetHeight(height);
		border = getglobal(name.."_3");
		border:SetHeight(height);
		border = getglobal(name.."_4");
		border:SetHeight(height);
	end;
end;

function CPala.Class.Box.prototype:OnDragStart()
	if (self.unlocked) then
		this:StartMoving();
	end;
end

function CPala.Class.Box.prototype:OnDragStop()
	this:StopMovingOrSizing();
	if (self.DragEnd) then
		local _, _, _, x, y = self.box:GetPoint()
		self.DragEnd(x, y);
	end;
end

function CPala.Class.Box.prototype:SetBorderVisible(check)
	local border;
	local name = self.box:GetName();
	if (check) then
		border = getglobal(name.."_1");
		border:Show();	
		border = getglobal(name.."_2");
		border:Show();	
		border = getglobal(name.."_3");
		border:Show();	
		border = getglobal(name.."_4");
		border:Show();	
	else
		border = getglobal(name.."_1");
		border:Hide();	
		border = getglobal(name.."_2");
		border:Hide();	
		border = getglobal(name.."_3");
		border:Hide();	
		border = getglobal(name.."_4");
		border:Hide();	
	end;
end;