-- Buff Need List and Casting ...

-- structure Key = Unit Name 1 = spell name 2 = group buff 3 = other buff acitve 4 = ignore unit
CPala.needList = {};

--buff currently shown as needed
local currentNeed;
local currentNeedSmall;
local currentUnit;

--Header of The box for keybinding
CPala.needHeader = nil;
CPala.needBox = nil;

--count of missing group buffs, and used as Class List ;)
CPala.greaterCount = {
	["WARRIOR"] = 0,
	["PALADIN"] = 0,
	["MAGE"] = 0,
	["HUNTER"] = 0,
	["SHAMAN"] = 0,
	["PRIEST"] = 0,
	["ROGUE"] = 0,
	["DRUID"] = 0,
	["WARLOCK"] = 0,
}

CPala.classList = {
	["WARRIOR"] = "Warrior",
	["PALADIN"] = "Paladin",
	["MAGE"] = "Mage",
	["HUNTER"] = "Hunter",
	["SHAMAN"] = "Shaman",
	["PRIEST"] = "Priest",
	["ROGUE"] = "Rogue",
	["DRUID"] = "Druid",
	["WARLOCK"] = "Warlock",
}

local roster = AceLibrary("Roster-2.1");

function CPala:InitBuffNeed()
	-- Create the Buff Mesage box
	local db = self.db.char;
	local box = CPala.Class.Box:new("NeedBox", "Nothing", 180, 18, db.buffBox.x, db.buffBox.y, "Button", "CPala_Box_Template, SecureActionButtonTemplate");
	self.needbox = box;
	box.DragEnd = function (x, y)
		db.buffBox.x = x;
		db.buffBox.y = y;
	end;
	box:SetBorderVisible(db.boxBorder);
	box:Show();
	if (db.boxLock) then
		box:Lock();
	else
		box:Unlock();
	end;
	
	local frame = box.box;
	frame:RegisterForClicks("AnyUp");

	--Create Header for Keybindings
	local p = CreateFrame("Frame", "NeedBoxHeader", UIParent, "SecureStateHeaderTemplate");
	p:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", 0, 0);
	p:SetAttribute("statebindings", "0:^main");    
 	p:SetAttribute("AddChild", frame);
	p:SetAttribute("state", "0");
	self.needHeader = p;

	--Set Visbilty
	frame:SetAttribute("newstate", "*:=");
	frame:SetAttribute("showstates", "*");
	--Set Base Actions
	frame:SetAttribute("type1", "update"); -- Left Click : Buff or Update		
	frame:SetAttribute("type2", "spell"); -- RightClick Buff Small
	frame:SetAttribute("type3", "update"); -- Middle Click : Update
	frame:SetAttribute("type4", "ignore"); --Button 4 : Ignore This need
	
	frame.ignore = function() CPala:Ignore() end;
	frame.update = function() CPala:CheckBuffNeed(true) end;		
end;


function CPala:EnableBuffNeed()		
	-- check only every 30 seconds, that should be enough
	self:ScheduleRepeatingEvent(self.CheckBuffNeed, 30, self);
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("CPALA_UPDATE_LIST", "UpdateBox");
	-- register key
	self:SetBuffBoxKeys();
end;

--KeyBinding Text
BINDING_NAME_CPALA_AutoBuff = "Auto Buff Spell or Update";
BINDING_NAME_CPALA_AutoBuffSmall = "Auto Buff Short Blessing";
BINDING_NAME_CPALA_AutoBuffUpdate = "Auto Buff Update";
BINDING_NAME_CPALA_AutoBuffIgnore = "Auto Buff Ignore Spell";

function CPala:SetBuffBoxKeys()
	--First Build Key string ...
	local keystring = "";
	
	local key, key2 = GetBindingKey("CPALA_AutoBuff");
	if (key) then
		keystring = keystring .. key .. ":LeftButton;";
	end;
	if (key2) then
		keystring = keystring .. key2 .. ":LeftButton;";
	end;
	
	key, key2 = GetBindingKey("CPALA_AutoBuffSmall");
	if (key) then
		keystring =  keystring .. key .. ":RightButton;";
	end;
	if (key2) then
		keystring = keystring .. key2 .. ":RightButton;";
	end;
	
	key, key2 = GetBindingKey("CPALA_AutoBuffUpdate");
	if (key) then
		keystring =  keystring .. key .. ":MiddleButton;";
	end
	if (key2) then
		keystring = keystring .. key2 .. ":MiddleButton;";
	end;
	
	key, key2 = GetBindingKey("CPALA_AutoBuffIgnore");
	if (key) then
		keystring =  keystring .. key .. ":Button4;";
	end
	if (key2) then
		keystring = keystring .. key2 .. ":Button4;";
	end;
	
	--After That set this keystring	
	self.needbox.box:SetAttribute("bindings-main", keystring);	
	self.needHeader:SetAttribute("state", "0"); --Reset State after Value Changes
end;

local function CallFunction()
	CPala:CheckBuffNeed();
end;

function CPala:BuffNeedAura(unit)
	if ((currentNeed) and (unit == currentUnit)) then		
		if ((self:HasBuff(unit, currentNeed) or  self:HasBuff(unit, currentNeedSmall)) or (currentNeed == "Righteous Fury")) then			
			--self:CheckBuffNeed();
			self:ScheduleEvent(CallFunction, 0.2);  --Schedule a bit because of greater buffs not update all at the same time
			castTarget = nil;
			castSpell = nil;
		end;
	end;			
end;


function CPala:CheckBuffNeed(ignoreFirst)
	
	local need;
	local spell;
	local greaterCount = self.greaterCount; -- local Copys
	local needList = self.needList;
	local buffList = self.buffList;
	local selfbuff = self.selfbuff;
	local none = self.none;
	local defaultBlessings = self.db.char.defaultBlessings;
	
	--Reset Greater Count
	for key in pairs(greaterCount) do
		greaterCount[key] = 0;
	end

	--Selfbuff
	if needList[selfbuff] then
		--reuse old table entry
		need = needList[selfbuff];
	else
		-- Create new table entry
		needList[selfbuff] = {none, false, false, false};
		need = needList[selfbuff];
	end;
	if (not need[4]) then
		spell = defaultBlessings[selfbuff];
		if (spell) then
			if ((spell ~= none) and (not self:HasBuffAll("player", spell))) then
				need[1] = spell;
				need[2] = true; -- Not Really Greater but Imprortant ...				
			else
				need[1] = none;
			end;
		end;
	end;

	local name;
	local class;
	
	-- for all raid units
	for unit in roster:IterateRoster(false) do
		-- only iterate for existing units ...
		if (unit) then		
		name = unit.name;
		class = unit.class;
		if needList[name] then
			need = needList[name]; -- reuse of table entrys
			need[3] = false; --reset overbuffed state
		else
			--create new entry
			needList[name] = {none, false, false, false};
			need = needList[name];			
		end;
		-- if not ignored
		if (not need[4]) then
			--first get spell by name or if fail by class
			spell = defaultBlessings[name];			
			if (not spell) then
				spell = defaultBlessings[class];
			end;
			if (spell) then				
				--check if buff already active
				if ((spell ~= none) and (unit.online) and (UnitIsVisible(unit.unitid)) and  (not UnitIsDeadOrGhost(unit.unitid)) and (not self:HasBuff(unit.unitid, spell)) ) then
					need[1] = spell;										
					if (buffList[name] and (not buffList[name][4])) or ((not defaultBlessings[name]) and buffList[class] and self:HasBuff(unit.unitid, buffList[class][1])) then
						need[3] = true; -- other buff active do not add to need list
					elseif (strfind(spell, "Greater")) then  -- greater buff
						need[2] = true;
						greaterCount[class] = greaterCount[class] + 1;
					else
						need[2] = false;
					end;
				else
					need[1] = none;
					need[2] = false;
					need[3] = false;
				end;
			end;
		end;
		end;
    end;
	
	-- After Updating the list we should Update our box ;)			
	self:TriggerEvent("CPALA_UPDATE_LIST", ignoreFirst);
end;



--Update Need Box information
function CPala:UpdateBox(ignoreFirst)
	local show, show_a;
	local name, name_a;
	local count = 0;	
	local oor = false;
	local obj; -- Get Unit Information
	local box = self.needbox.box;	
	local selfbuff = self.selfbuff;
	
	for key, entry in pairs(self.needList) do
		if (entry[1] ~= self.none)  and (not entry[3]) then
			count = count + 1;
			if (not show) then --select first entry
				
				--Range Check
				if (key == selfbuff) then
					obj = roster:GetUnitObjectFromName(UnitName("player"));					
				else
					obj = roster:GetUnitObjectFromName(key);
				end;
								
				if (obj) then
					if (IsSpellInRange(entry[1], obj.unitid) ~= 0) and ((ignoreFirst and (entry ~= currentNeed)) or (not ignoreFirst)) and (not self:HasBuff(obj.unitid, entry[1])) then									
						show = entry;
						name = key;
					else
						show_a = entry; --save as secondary
						name_a = key;
					end;					
				else					
					self.needList[key] = nil; -- clear non existing raidmembers					
				end;
			elseif (entry[2] and (not show[2])) then
				--Priotrize Greater Buffs Needs
				--Range Check
				if (key == selfbuff) then
					obj = roster:GetUnitObjectFromName(UnitName("player"));					
				else
					obj = roster:GetUnitObjectFromName(key);
				end;								
				
				if (obj) then									
					if (IsSpellInRange(entry[1], obj.unitid) ~= 0) and ((ignoreFirst and (entry ~= currentNeed)) or (not ignoreFirst)) and (not self:HasBuff(obj.unitid, entry[1])) then									
						show = entry;
						name = key;
					else
						show_a = entry; --save as secondary
						name_a = key;
					end;			
				else					
					self.needList[key] = nil;					
				end;
			end;				
		end;
	end;
	
	--Clear Last Current because it will be reset soon
	currentNeed = nil;			
	currentUnit = nil;
	
		
	self:TriggerEvent("CPALA_UPDATE_SUMMARY", count, nil, nil, nil); -- Update Fu Text
		
	-- if we not found a pirmary show target then use secondary
	if (not show) then
		show = show_a;
		name = name_a;
		oor = true;	
	end;
				
	if (not show)  then				
		-- Nothing Needed/Nothing in Range
		--search for shortest remaning buff
		local delta;
		local shortest = 1800;
		show = nil;
		local t = time();
		for target, entry in pairs(self.buffList) do
			delta = entry[3] - (t - entry[2]);
			if (delta > 0) and (delta < shortest) and (not entry[4]) then
				shortest = delta;
				show = entry;
				name = target;					
			end;
		end;
	
		if (show) then
			if self.classList[name] then -- replace Upper Class Name
				name = self.classList[name];
			end;			
			self:SetNeedBoxConfig(format("%s on %s in %s", self.shortcuts[show[1]], name, self:FormatSeconds(shortest)), "update", nil, nil, nil );
		else
			self:SetNeedBoxConfig("Nothing", "update", nil, nil, nil );
		end;

		return;	-- Abort 
	end;

	--regrab obj entry 
	if (name == selfbuff) then
		obj = roster:GetUnitObjectFromName(UnitName("player"));					
	else
		obj = roster:GetUnitObjectFromName(name);
	end;	
	
	if (obj) then
		local text;	
		if (show[2] and (not show[3])) then
			--gerater buff
			text = format("(%i) %s need %s (x%i)", count, name, self.shortcuts[show[1]], self.greaterCount[obj.class]);
		else
			--small buff
			text = format("(%i) %s need %s", count, name, self.shortcuts[show[1]]);
		end;
		if (oor) then		-- out of range indicator
			text = format("(%s)", text);
		end;
		
		if (show[2]) then
			-- if greater buff add small buff as right click
			self:SetNeedBoxConfig(text, "spell", obj.unitid, show[1], strsub(show[1], 9) );			
		else -- else double normal
			self:SetNeedBoxConfig(text, "spell", obj.unitid, show[1], show[1]);			
		end;
		
	else		
		-- Remove no Longer avilable Players
		self.needList[name] = nil;
		self:UpdateBox();  -- Restart
	end;	
end;

--Just a Shortcut for the same command sequence
function CPala:SetNeedBoxConfig(text, type1, unit, spell1, spell2) 
	local box = self.needbox.box;
	if (not InCombatLockdown()) then		
		box:SetAttribute("type1", type1);
		box:SetAttribute("unit", unit);
		box:SetAttribute("spell1", spell1);
		box:SetAttribute("spell2", spell2);	
	else	
		if (spell1) then --if a spell was set add the "warning in combat" indicator
			text = format("-- %s --", text);
		end;
	end;	
	self.needbox:SetText(text);
	--current Need Set for UNIT_AURA to find ;)
	currentNeed = spell1;
	currentNeedSmall = spell2;
	currentUnit = unit;
end;

function CPala:Ignore()
	if currentUnit and currentNeed then
		local name = UnitName(currentUnit);
		self:Msg(string.format("Now Ignoring Buff need for %s!", currentNeed, name));
		if (self.needList[name]) then
			self.needList[name][4] = true;
			self.needList[name][1] = self.none;
			self:UpdateBox();		
		end;		
	end;
end;
--[[
function CPala:SetBuffKey(value)
	local db = self.db.char.buffBox;
	if db.key ~= value then
		db.key = value;	
		SetBindingClick(db.key, "NeedBox");
		self:Print("New Buff Key Set, Old Key will be Active till Reload!");
	end 
end;
]]

--Activate and Deactivte Direct Buffing during Combat
function CPala:PLAYER_REGEN_DISABLED()
	self.needbox.box:SetAttribute("type1", "update");	
	self.needbox.box:SetAttribute("spell2", "");
end;

function CPala:PLAYER_REGEN_ENABLED()
	self:UpdateBox();	
end;