
local groupBuffs;  -- The Menu Objects
local soloBuffs;
local specials;


function CPala:InitMenus()
	local db = self.db.char.menu; -- time saver
	local bClass = self.Class.BaseButton;
	local mClass = self.Class.CursorBar
	
	if (db.greater) then
		groupBuffs = mClass:new("CPalaGreaterBlessings", 2, true)
		local button;
		groupBuffs:SetKey(db.geraterKey);
		groupBuffs:UpdateButtonPosition("ROUND", 40);
		groupBuffs:VisibleOnlyForUnit("mouseover");
			
		button = groupBuffs:AddButton(bClass);
		button:Setup("B1", "1", false, groupBuffs.frame);
		button:SetButtonActionSingle("spell", "Greater Blessing of Wisdom", nil, "mouseover");

		button = groupBuffs:AddButton(bClass);
		button:Setup("B2", "2", false, groupBuffs.frame);
		button:SetButtonActionSingle("spell", "Greater Blessing of Might", nil, "mouseover");

		button = groupBuffs:AddButton(bClass);
		button:Setup("B3", "3", false, groupBuffs.frame);
		button:SetButtonActionSingle("spell", "Greater Blessing of Light", nil, "mouseover");
	
		button = groupBuffs:AddButton(bClass);
		button:Setup("B4", "4", false, groupBuffs.frame);
		button:SetButtonActionSingle("spell", "Greater Blessing of Salvation", nil, "mouseover");
	
		if (db.bok) then
			button = groupBuffs:AddButton(bClass);
			button:Setup("B5", "5", false, groupBuffs.frame);
			button:SetButtonActionSingle("spell", "Greater Blessing of Kings", nil, "mouseover");
		end;
	
		if (db.bosa) then
			button = groupBuffs:AddButton(bClass);
			button:Setup("B6", "6", false, groupBuffs.frame);
			button:SetButtonActionSingle("spell", "Greater Blessing of Sanctuary", nil, "mouseover");
		end;
	end;
	
	if (db.normal) then		
		soloBuffs = mClass:new("CPalaBlessings", 2, true)
		local button;
		soloBuffs:SetKey(db.normalKey);
		soloBuffs:UpdateButtonPosition("ROUND", 40);
		--soloBuffs:VisibleOnlyForUnit("mouseover");
			
		button = soloBuffs:AddButton(bClass);
		button:Setup("B1", "1", false, soloBuffs.frame);
		button:SetButtonActionSingle("spell", "Blessing of Wisdom", nil, "mouseover");

		button = soloBuffs:AddButton(bClass);
		button:Setup("B2", "2", false, soloBuffs.frame);
		button:SetButtonActionSingle("spell", "Blessing of Might", nil, "mouseover");

		button = soloBuffs:AddButton(bClass);
		button:Setup("B3", "3", false, soloBuffs.frame);
		button:SetButtonActionSingle("spell", "Blessing of Light", nil, "mouseover");
	
		button = soloBuffs:AddButton(bClass);
		button:Setup("B4", "4", false, soloBuffs.frame);
		button:SetButtonActionSingle("spell", "Blessing of Salvation", nil, "mouseover");
	
		if (db.bok) then
			button = soloBuffs:AddButton(bClass);
			button:Setup("B5", "5", false, soloBuffs.frame);
			button:SetButtonActionSingle("spell", "Blessing of Kings", nil, "mouseover");
		end;
	
		if (db.bosa) then
			button = soloBuffs:AddButton(bClass);
			button:Setup("B6", "6", false, soloBuffs.frame);
			button:SetButtonActionSingle("spell", "Blessing of Sanctuary", nil, "mouseover");
		end;
	end;
	
	if (db.special) then
		specials = mClass:new("CPalaSpecials", 2, true)
		specials:SetKey(db.specialKey);
		specials:VisibleOnlyForUnit("mouseover");
		specials:UpdateButtonPosition("ROUND", 35);
	
		button = specials:AddButton(bClass);
		button:Setup("B1", "1", false, specials.frame);
		button:SetButtonActionSingle("spell", "Blessing of Protection", nil, "mouseover");

		button = specials:AddButton(bClass);
		button:Setup("B2", "2", false, specials.frame);
		button:SetButtonActionSingle("spell", "Blessing of Freedom", nil, "mouseover");

		button = specials:AddButton(bClass);
		button:Setup("B3", "3", false, specials.frame);
		button:SetButtonActionSingle("spell", "Blessing of Sacrifice", nil, "mouseover");

		button = specials:AddButton(bClass);
		button:Setup("B4", "4", false, specials.frame);
		button:SetButtonActionSingle("spell", "Lay on Hands", nil, "mouseover");

		button = specials:AddButton(bClass);
		button:Setup("B5", "5", false, specials.frame);
		button:SetButtonActionSingle("spell", "Divine Intervention", nil, "mouseover");	
	end;

end;

function CPala:SetSoloKey(value)
	self.db.char.menu.normalKey	= value;
	soloBuffs:SetKey(value);
end;

function CPala:SetSpecialKey(value)
	self.db.char.menu.specialKey = value;
	specials:SetKey(value);
end;

function CPala:SetGreaterKey(value)
	self.db.char.menu.greaterKey = value;
	groupBuffs:SetKey(value);
end;


--[[
function CPala:SetMenuKeys()
	local key;

end;
]]