-- Seal Box and Cleanse Reminder Stuff

--Auras on Target
local noSeal = true;
local lastCleanse; -- limit message spam

CPala.sealbox = true;

function CPala:InitSealBox()
	-- Create the Seal Mesage box
	local db = self.db.char;
	local box = CPala.Class.Box:new("SealBox", "None", 60, 18, db.sealBox.x, db.sealBox.y );
	box.DragEnd = function (x, y)
		db.sealBox.x = x;
		dbsealBox.y = y;
	end;
	box:SetBorderVisible(db.boxBorder);
	box:Show();
	if (db.boxLock) then
		box:Lock();
	else
		box:Unlock();
	end;
	self.sealbox = box;
end;

function CPala:EnableSealBox()
	self:RegisterEvent("PLAYER_AURAS_CHANGED");
	self:RegisterEvent("PLAYER_TARGET_CHANGED", "PLAYER_AURAS_CHANGED");
	self:RegisterEvent("PLAYER_ENTER_COMBAT", "PLAYER_AURAS_CHANGED");
	self:RegisterEvent("PLAYER_LEAVE_COMBAT", "PLAYER_AURAS_CHANGED");	
	lastCleanse = time();
end;


function CPala:SealBoxAura(unit)	
	if (unit == "target") then		
		if (noSeal) then
			return;
		end;
		local sealbox = self.sealbox;
		local text;
		local i = 1;
		local buff_name = UnitDebuff("target", i, true); -- we can cleanse our own debuff ...
		local short;
		while (buff_name) do	
			short = self.shortcuts[buff_name];
			if short then
				if (text) then
					text = format("%s; %s", text, short);
				else
					text = short;
				end;
			end;
			i = i + 1;
			buff_name = UnitDebuff("target", i, true);
		end;
		if (text) then
			sealbox:Show();
			sealbox:SetText(text);		
			self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, text);			
		else
			sealbox:Hide();			
			self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, "");			
		end;
	-- Range Check longer then actuall distance ;)
	elseif UnitCanAssist(unit, "player") and UnitDebuff(unit, 1, true) and (IsSpellInRange("Flash of Light", unit) ~= 0) then
		local t = time();
		if (t - lastCleanse) > 5 then
			lastCleanse = t;
			--Message
			local text = format("***Need Cleanse*** (%s)", UnitName(unit));
			UIErrorsFrame:AddMessage(text);
			ChatFrame2:AddMessage(text);
		end
	end;	
end;

function CPala:PLAYER_AURAS_CHANGED()
	local sealbox = self.sealbox;
	if (not UnitExists("target")) then
		sealbox:Hide();		
		noSeal = false;
		self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, "");	
		return;
	end;
	if (not UnitCanAttack("player", "target")) then
		sealbox:Hide();		
		noSeal = false;
		self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, "");	
		return;
	end;
	if (IsCurrentAction(1)) then
		local i = 1;
		local buff_name = UnitBuff("player", i, false);
		while (buff_name) do
			if strfind(buff_name, "Seal") then
				noSeal = false;
				sealbox:Hide();
				self:SealBoxAura("target");
				return;
			end;
			i = i + 1;
			buff_name = UnitBuff("player", i, false);
		end;
		sealbox:Show();
		sealbox:SetText("No Seal!");	
		self:TriggerEvent("CPALA_UPDATE_SUMMARY", nil, nil, nil, "No Seal!");			
		noSeal = true;
	else
        noSeal = false;
		self:SealBoxAura("target");
	end;
end;